From 4a82cbebc8790ad11dedf0f426d49e57f3f0ce82 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jun 05 2015 16:33:28 +0000
Subject: [PATCH 81/1001] Pendingacls workflow widget.


---

diff --git a/hubs/models.py b/hubs/models.py
index d5c257f..87ddada 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -113,9 +113,11 @@ class Hub(BASE):
                             'username': username,
                         }))
         hub.widgets.append(widget)
-        widget = Widget(plugin='sticky', index=1,
+        widget = Widget(plugin='workflow.pendingacls', index=1,
                         _config=json.dumps({
-                            'text': 'TODO -- your feed goes here.',
+                            # Only because he has pendingacls to test against
+                            'username': 'vicodan',
+                            #'username': username,
                         }))
         hub.widgets.append(widget)
         widget = Widget(plugin='badges', index=2,
diff --git a/hubs/utils.py b/hubs/utils.py
new file mode 100644
index 0000000..35bf44a
--- /dev/null
+++ b/hubs/utils.py
@@ -0,0 +1,14 @@
+from hashlib import sha256
+
+from six.moves.urllib_parse import urlencode
+
+
+def username2avatar(username, s=312):
+    query = urlencode({
+        'd': 'retro',
+        's': s,
+    })
+    openid = 'http://%s.id.fedoraproject.org/' % username
+    hash = sha256(openid.encode('utf-8')).hexdigest()
+    avatar = "https://seccdn.libravatar.org/avatar/%s?%s" % (hash, query)
+    return avatar
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 4d3dff9..51ed1b1 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -6,6 +6,8 @@ from hubs.widgets import about
 from hubs.widgets import avatar
 from hubs.widgets import badges
 
+from hubs.widgets.workflow import pendingacls
+
 from hubs.widgets.base import AGPLv3, smartcache
 
 registry = {
@@ -16,6 +18,8 @@ registry = {
     'about': about,
     'avatar': avatar,
     'badges': badges,
+
+    'workflow.pendingacls': pendingacls,
 }
 
 
diff --git a/hubs/widgets/avatar.py b/hubs/widgets/avatar.py
index 7360773..20c12ab 100644
--- a/hubs/widgets/avatar.py
+++ b/hubs/widgets/avatar.py
@@ -1,11 +1,8 @@
-from hashlib import sha256
-
 from hubs.widgets.base import argument
+from hubs.utils import username2avatar
 
 import jinja2
 
-from six.moves.urllib_parse import urlencode
-
 import hubs.validators as validators
 
 
@@ -22,15 +19,7 @@ template = jinja2.Template("""
           validator=validators.username,
           help="A FAS username.")
 def data(session, widget, username):
-
-    query = urlencode({
-        'd': 'retro',
-        's': 312,
-    })
-    openid = 'http://%s.id.fedoraproject.org/' % username
-    hash = sha256(openid.encode('utf-8')).hexdigest()
-    avatar = "https://seccdn.libravatar.org/avatar/%s?%s" % (hash, query)
-
+    avatar = username2avatar(username)
     return dict(username=username, avatar=avatar)
 
 
diff --git a/hubs/widgets/workflow/pendingacls.py b/hubs/widgets/workflow/pendingacls.py
new file mode 100644
index 0000000..40149e4
--- /dev/null
+++ b/hubs/widgets/workflow/pendingacls.py
@@ -0,0 +1,53 @@
+import requests
+
+from hubs.widgets.base import argument
+from hubs.utils import username2avatar
+
+import jinja2
+
+
+import hubs.validators as validators
+
+# TODO -- add approve/deny buttons or just link through to pkgdb
+template = jinja2.Template("""
+{% if pending_acls %}
+<a class="btn btn-success" target="_blank" href="https://admin.fedoraproject.org/pkgdb/acl/pending/">Manage requests</a>
+<hr/>
+<ul class="media-list">
+{% for acl in pending_acls %}
+    <li class="media">
+        <div class="media-left">
+            <img class="media-object img-responsive img-circle" src="{{acl['avatar']}}"/>
+        </div>
+        <div class="media-body">
+            <h4 class="media-heading">{{acl['user']}} is {{acl['status']}}</h4>
+            for {{acl['acl']}} on
+            {{acl['package']}}({{acl['collection']}})
+        </div>
+    </li>
+{% endfor %}
+</ul>
+{% endif %}
+""")
+
+from hubs.widgets.chrome import panel
+chrome = panel("Pending ACLs")
+
+
+@argument(name="username",
+          default=None,
+          validator=validators.username,
+          help="A FAS username.")
+def data(session, widget, username):
+    baseurl = "https://admin.fedoraproject.org/pkgdb/api/pendingacls"
+    query = "?username={username}&format=json".format(username=username)
+    url = baseurl + query
+    response = requests.get(url)
+    data = response.json()
+    for acl in data['pending_acls']:
+        acl['avatar'] = username2avatar(acl['user'], s=32)
+    return data
+
+
+def should_invalidate(message, session, widget):
+    raise NotImplementedError

